package
{
	import flash.events.*;
	import flash.display.Loader;
	import com.adobe.images.*;
    import flash.display.*;
    import flash.filters.*;
    import flash.geom.*;
    import flash.net.*;
    import flash.ui.*;
    import flash.utils.*;
	import flash.utils.Dictionary;
	import obj.*;
    import obj.animation.*;
    import obj.dialogue.*;
    import obj.ui.*;
	
	public dynamic class DialogueAuto extends flash.display.MovieClip
	{
		public var Dialogue:Class;
		public var DialogueLine:Class;
		public var Word:Class;
		private var DAFound:Boolean = false;
		public var tX:Number;
		public var tY:Number;
		public var count:Number = 1;
		public var customActive:Boolean = false;
		public var customPause:Boolean = false;
		public var aCon:Boolean;
		public var autoMode:Boolean;
		public var playRec:Boolean;
		public var holdDown:Boolean;
		public var holdPoint:Point = new Point(0,0);
		public var minX:Number = 0;
		public var maxX:Number = 0;
		public var minY:Number = 0;
		public var maxY:Number = 0;
		public var speedDownX:Number = 0;
		public var speedUpX:Number = 0;
		public var speedDownY:Number = 0;
		public var speedUpY:Number = 0;
		public var delayDownX:Number = 0;
		public var delayUpX:Number = 0;
		public var delayDownY:Number = 5;
		public var delayUpY:Number = 5;
		public var baseMinX:Number = 0;
		public var baseMaxX:Number = 0;
		public var baseSpeedDownX:Number = 0;
		public var baseSpeedUpX:Number = 0;
		public var baseDelayDownX:Number = 0;
		public var baseDelayUpX:Number = 0;
		public var minXIncrease:Number = 0;
		public var maxXIncrease:Number = 0;
		public var speedDownXIncrease:Number = 0;
		public var speedUpXIncrease:Number = 0;
		public var delayDownXIncrease:Number = 0;
		public var delayUpXIncrease:Number = 0;
		public var baseMinY:Number = 0;
		public var baseMaxY:Number = 0;
		public var baseSpeedDownY:Number = 0;
		public var baseSpeedUpY:Number = 0;
		public var baseDelayDownY:Number = 0;
		public var baseDelayUpY:Number = 0;
		public var minYIncrease:Number = 0;
		public var maxYIncrease:Number = 0;
		public var speedDownYIncrease:Number = 0;
		public var speedUpYIncrease:Number = 0;
		public var delayDownYIncrease:Number = 0;
		public var delayUpYIncrease:Number = 0;
		public var frequencyOfIncreaseX:Number = 0;
		public var frequencyOfIncreaseY:Number = 0;
		public var randomChanceX:Number = 0;
		public var randomChanceY:Number = 0;
		public var randomScaleX:Number = 0;
		public var randomScaleY:Number = 0;
		public var endDirectX = false;
		public var endDirectY = false;
		public var tests:Array = new Array();
		public var main;
		public var g;
		public var lProxy:Class;
		public var lp;
		public var lp2;
		public var lp3;
		public var dialogueAPI:Dictionary;
		public var register:Function;
		public var runTrig:Function;
		private const API_DA:String = "DialogueActions";
		private var o:MovieClip;
		private const baseHilt = 610;
		private const baseTipDiff = 403;
		private const baseMidDiff = 167;
		private const baseHeadDiff = 327.5;
		private var missedTime =  0;
		private var missed:Boolean = false;
		private var lastGPosX:Number = 0;
		private var lastGPosY:Number = 0;
		private var finishX:Boolean = false;
		private var finishY:Boolean = false;
		private var goingDownX:Boolean = false;
		private var goingDownY:Boolean = false;
		private var lickSetup:Boolean = false;
		private var tongue:Boolean = false;
		private var penOut:Boolean;
		private var maxSpeedX = 0.24;
		private var maxSpeedY = 0.36;
		private var mousePressed = false;
		private var callbackActive:Boolean = false;
		private var callbackLine:String = "";
		
		public function DialogueAuto(){
		}
		
		public function initl(l):void {
			main = l;
			g = l.g;
			var tempDict:Dictionary = new Dictionary();
			tempDict["apiRegister"] = function(apiName:String, apiDict:Dictionary) {
				if(apiName == API_DA) doStuff();
			}
			l.registerAPI("DA_Extension", tempDict, true);
			setToDefaults();
			//main.registerUnloadFunction(finish);
			main.unloadMod();
		}	
		
		public function apiNotify() : void
		{
			doStuff();
		}
		
		private function doStuff() : void{
			dialogueAPI = main.getAPI(API_DA);
			if (!DAFound){
				if (dialogueAPI == null){
					main.updateStatus(DAFound);
					return;
				} else {
					DAFound = true; 
					if (!addTriggers()){
						main.updateStatus("Dictionary Load Failed");
						main.unloadMod();
					} else {
						main.updateStatus("CustomAutomation loaded successfully");
					}
					lProxy = main.getLoaderClass("Modules.lProxy");
					lp2 = lProxy.createProxy(g, "setAuto");
					lp2.addPost(stopProxy(), false);
				}
			}
			Dialogue = main.eDOM.getDefinition("obj.dialogue.Dialogue") as Class;
			DialogueLine = main.eDOM.getDefinition("obj.dialogue.DialogueLine") as Class;
			Word = main.eDOM.getDefinition("obj.dialogue.Word") as Class;
			//setup test array.
			var test0 = new Object();
			test0.func = null;
			test0.value = Number.NaN;
			test0.active = false;
			test0.comp = null;
			test0.trigger = null;
			test0.repeat = 0;
			tests.push(test0);
			var test1 = new Object();
			test1.func = null;
			test1.value = Number.NaN;
			test1.active = false;
			test1.comp = null;
			test1.trigger = null;
			test1.repeat = 0;
			tests.push(test1);
			var test2 = new Object();
			test2.func = null;
			test2.value = Number.NaN;
			test2.active = false;
			test2.comp = null;
			test2.trigger = null;
			test2.repeat = 0;
			tests.push(test2);
		}
		
		private function addTriggers():Boolean{
			register = dialogueAPI["registerTrigger"].getFunction();
			runTrig = dialogueAPI["runTriggerCode"].getFunction();
			register("FULL_CUSTOM", 6, autoCustomFull, this, []);
			register("FULL_CUSTOM", 7, autoCustomFull, this, []);
			register("FULL_CUSTOM", 8, autoCustomFull, this, []);
			register("FULL_CUSTOM", 9, autoCustomFull, this, []);
			register("FULL_CUSTOM", 10, autoCustomFull, this, []);
			register("X_CUSTOM", 3, autoCustomX, this, []);
			register("X_CUSTOM", 4, autoCustomX, this, []);
			register("X_CUSTOM", 5, autoCustomX, this, []);
			register("X_CUSTOM", 6, autoCustomX, this, []);
			register("ACTIVATE_CUSTOM", 0, activateCustom, this, []);
			register("POSITION_CUSTOM", 3, positionCustom, this, []);
			register("STOP_CUSTOM", 0, stopCustom, this, null);
			register("HOLD_CUSTOM", 0, customHold, this, null);
			register("MOVE_TONGUE", 1, moveTongue, this, []);
			register("MOUSE_BUTTON", 1, mouseSet, this, []);
			register("MOVE_TO_BALLS", 1, moveToBalls, this, []);
			register("INIT_RESISTANCE", 1, changeInitRes, this, []);
			register("INIT_RESIST_BREAK", 1, breakInitRes, this, []);
			register("INIT_RESIST_BREAK", 2, breakInitRes, this, []);
			register("PAUSE_CUSTOM", 0, pauseCustom, this, null);
			register("CONTINUE_CUSTOM", 0, continueCustom, this, null);
			register("VALUE_CUSTOM", 2, alterValue, this, []);
			register("VALUE_CUSTOM", 4, alterValue, this, []);
			register("VALUE_CUSTOM", 6, alterValue, this, []);
			register("VALUE_CUSTOM", 8, alterValue, this, []);
			register("VALUE_CUSTOM", 10, alterValue, this, []);
			register("VALUE_CUSTOM", 12, alterValue, this, []);
			register("VALUE_CUSTOM", 14, alterValue, this, []);
			register("VALUE_CUSTOM", 16, alterValue, this, []);
			register("VALUE_CUSTOM", 18, alterValue, this, []);
			register("VALUE_CUSTOM", 20, alterValue, this, []);
			register("VALUE_CUSTOM", 22, alterValue, this, []);
			register("VALUE_CUSTOM", 24, alterValue, this, []);
			register("VALUE_CUSTOM", 26, alterValue, this, []);
			register("VALUE_CUSTOM", 28, alterValue, this, []);
			register("VALUE_CUSTOM", 30, alterValue, this, []);
			register("VALUE_CUSTOM", 32, alterValue, this, []);
			register("VALUE_CUSTOM", 34, alterValue, this, []);
			register("VALUE_CUSTOM", 36, alterValue, this, []);
			register("VALUE_CUSTOM", 38, alterValue, this, []);
			register("VALUE_CUSTOM", 40, alterValue, this, []);
			register("VALUE_CUSTOM", 42, alterValue, this, []);
			register("VALUE_CUSTOM", 44, alterValue, this, []);
			register("VALUE_CUSTOM", 46, alterValue, this, []);
			register("VALUE_CUSTOM", 48, alterValue, this, []);
			register("VALUE_CUSTOM", 50, alterValue, this, []);
			register("VALUE_CUSTOM", 52, alterValue, this, []);
			register("VALUE_CUSTOM", 54, alterValue, this, []);
			register("VALUE_CUSTOM", 56, alterValue, this, []);
			register("VALUE_CUSTOM", 58, alterValue, this, []);
			register("VALUE_CUSTOM", 60, alterValue, this, []);
			register("SET_TEST", 4, setTests, this, []);
			register("SET_TEST", 6, setTests, this, []);
			register("ACTIVE_TEST", 2, activeTest, this, []);
			register("RANDOM_ACTIVATE", 2, randomActivate, this, []);
			register("RANDOM_CUSTOM", 8, randomCustom, this, []);
			register("RANDOM_SPECIFY", 5, randomCustom, this, []);
			register("RANDOM_SPECIFY", 7, randomCustom, this, []);
			register("RANDOM_SPECIFY", 9, randomCustom, this, []);
			register("RANDOM_SPECIFY", 11, randomCustom, this, []);
			register("RAMP_ACTIVATE", 1, rampActivate, this, []);
			register("RAMP_CUSTOM", 13, rampCustom, this, []);
			register("RAMP_SPECIFY", 6, rampCustom, this, []);
			register("RAMP_SPECIFY", 8, rampCustom, this, []);
			register("RAMP_SPECIFY", 10, rampCustom, this, []);
			register("RAMP_SPECIFY", 12, rampCustom, this, []);
			register("RAMP_SPECIFY", 14, rampCustom, this, []);
			register("RAMP_SPECIFY", 16, rampCustom, this, []);
			register("RAMP_SPECIFY", 18, rampCustom, this, []);
			register("RAMP_SPECIFY", 20, rampCustom, this, []);
			register("RAMP_SPECIFY", 22, rampCustom, this, []);
			return true;
		}
		
		public function finish(){
			lProxy.restoreProxies(false);
			if (customActive){
				g.autoMode = autoMode;
				g.aCon = aCon;
				g.playRec = playRec;
				main.holdDown = holdDown;
				g.inGameMenu.setCBAuto();
				g.tongue = tongue;
				g.her.tongueToggled();
				g.inGameMenu.updateCBTongue();
				mousePressed = false;
				customActive = false;
			}
		}
		
		private function customStartCheck() : void{
			if (!customActive){
					autoMode = g.autoModeOn;
					aCon = main.aCon;
					playRec = main.playRec;
					holdDown = main.holdDown;
					tongue = g.tongue;
			}
			g.autoModeOn = true;
			main.aCon = true;
			main.playRec = true;
			main.holdDown = true;
			customActive = true;
			if (lProxy.checkProxied(g.automaticControl, "getPos"))
				lp.restoreProxy(false);
			lp = lProxy.createProxy(g.automaticControl, "getPos");
		}
		
		private function positionCustom(args):void{
			setToDefaults();
			minX = convertString(args[0]);
			minY = Number(args[1])/50 - 1;
			speedDownX = Number(args[2]) * maxSpeedX/100;
			if (minX < -0.2)
				minX = -0.2;
			else if (minX > 1.2)
				minX = 1.2;
			if (minY < -1)
				minY = -1;
			else if (minY > 1)
				minY = 1;
			if (speedDownX < maxSpeedX/100)
				speedDownX = maxSpeedX/100;
			else if (speedDownX > maxSpeedX)
				speedDownX = maxSpeedX;
			speedUpX = speedDownX;
			speedDownY = speedDownX;
			speedUpY = speedDownX;
			maxX = minX;
			maxY = minY;
			customStartCheck();
			lp.addPre(autoFunc(), false);
			lp.hooked = false;
		}
		
		private function autoCustomFull(args):void{
			minX = convertString(args[0]);
			maxX = convertString(args[1]);
			speedDownX = Number(args[2]) * maxSpeedX/100;
			speedUpX = speedDownX;
			minY = Number(args[3])/50 - 1;
			maxY = Number(args[4])/50 - 1;
			speedDownY = Number(args[5]) * maxSpeedY/100;
			speedUpY = Number(args[5]) * maxSpeedY/100;
			if (args.length >= 7)
				speedUpX = Number(args[6]) * maxSpeedX/100;
			if (args.length >= 8)
				speedUpY = Number(args[7]) * maxSpeedY/100;
			if (args.length >= 9){
				delayDownX = args[8];
				delayUpX = args[8];
			}
			if (args.length == 10)
				delayUpX = args[9];
			if (speedDownY > maxSpeedY)
				speedDownY = maxSpeedY;
			else if (speedDownY < maxSpeedY/100)
				speedDownY = maxSpeedY/100;
			if (speedUpY > maxSpeedY)
				speedUpY = maxSpeedY;
			else if (speedUpY < maxSpeedY/100)
				speedUpY = maxSpeedY/100;
			if (maxY > 1)
				maxY = 1
			else if (maxY < -1)
				maxY = -1;
			if (minY > 1)
				minY = 1
			else if (minY < -1)
				minY = -1;
			if (minY > maxY)
				minY = maxY;
			autoCustom();
		}

		private function autoCustomX(args){
			setToDefaults();
			minX = convertString(args[0]);
			maxX = convertString(args[1]);
			speedDownX = Number(args[2]) * maxSpeedX/100;
			speedUpX = speedDownX;
			if (args.length >= 4)
				speedUpX = Number(args[3]) * maxSpeedX/100;
			if (args.length >= 5){
				delayDownX = args[4];
				delayUpX = args[4];
			}
			if (args.length == 6)
				delayUpX = args[5];
			autoCustom();
		}
		
		private function activateCustom(args){
			autoCustom();
		}
		
		private function autoCustom():void{
			if (maxX > 1.2)
				maxX = 1.2
			else if (maxX < -0.2)
				maxX = -0.2;
			if (minX > 1.2)
				minX = 1.2
			else if (minX < -0.2)
				minX = -0.2;
			if (minX > maxX)
				minX = maxX;
			if (speedDownX > maxSpeedX)
				speedDownX = maxSpeedX;
			else if (speedDownX < maxSpeedX/100)
				speedDownX = maxSpeedX/100;
			if (speedUpX > maxSpeedX)
				speedUpX = maxSpeedX;
			else if (speedUpX < maxSpeedX/100)
				speedUpX = maxSpeedX/100;
			if (delayDownX < 1)
				delayDownX = 1;
			if (delayUpX < 1)
				delayUpX = 1;
			customStartCheck()
			lp.addPre(autoFunc(), false);
			lp.hooked = false;
		}

		private function randomCustom(args):void{
			setToDefaults();
			minX = convertString(args[0]);
			maxX = convertString(args[1]);
			speedDownX = Number(args[2]) * maxSpeedX/100;
			randomChanceX = Number(args[3])/1000;
			randomScaleX = Number(args[4])/100;
			if (randomChanceX < 0)
				randomChanceX = 0;
			else if (randomChanceX > 1)
				randomChanceX = 1;
			if (randomScaleX < 0)
				randomScaleX = 0;
			else if (randomScaleX > 100)
				randomScaleX = 100;
			if (speedDownX > maxSpeedX)
				speedDownX = maxSpeedX;
			else if (speedDownX < maxSpeedX/100)
				speedDownX = maxSpeedX/100;
			speedUpX = speedDownX;
			if (args.length == 8){
				speedUpX = Number(args[5]) * maxSpeedX/100;
				delayDownX = Number(args[6]);
				delayUpX = Number(args[7]);
			} else {
				var i:Number = 0;
				while (2* i + 5 < args.length){
					if (!specify(args[2 * i + 5], Number(args[2 * i + 6])))
						return;
					i++;
				}
			}
			baseMinX = minX;
			baseMaxX = maxX;
			baseSpeedDownX = speedDownX;
			baseSpeedUpX = speedUpX;
			baseDelayDownX = delayDownX;
			baseDelayUpX = delayUpX;
			autoCustom();
		}
		
		private function randomActivate(args){
			randomChanceX = Number(args[0])/1000;
			randomScaleX = Number(args[1])/100;
			if (randomChanceX < 0)
				randomChanceX = 0;
			else if (randomChanceX > 1)
				randomChanceX = 1;
			if (randomScaleX < 0)
				randomScaleX = 0;
			else if (randomScaleX > 100)
				randomScaleX = 100;
			frequencyOfIncreaseX = 1000000;
			frequencyOfIncreaseY = 1000000;
			autoCustom();
		}
		
		private function rampCustom(args){
			setToDefaults();
			minX = convertString(args[0]);
			maxX = convertString(args[1]);
			speedDownX = Number(args[2]) * maxSpeedX/100;
			frequencyOfIncreaseX = Number(args[3]);
			if (frequencyOfIncreaseX < 1)
				frequencyOfIncreaseX = 1;
			if (speedDownX > maxSpeedX)
				speedDownX = maxSpeedX;
			else if (speedDownX < maxSpeedX/100)
				speedDownX = maxSpeedX/100;
			speedUpX = speedDownX;
			if (args.length == 13){
				speedUpX = Number(args[4]) * maxSpeedX/100;
				delayDownX = Number(args[5]);
				delayUpX = Number(args[6]);
				minXIncrease = Number(args[7])/714.3;
				maxXIncrease = Number(args[8])/714.3;
				speedDownXIncrease = Number(args[9]) * maxSpeedX/1000;
				speedUpXIncrease = Number(args[10]) * maxSpeedX/1000;
				delayDownXIncrease = Number(args[11]);
				delayUpXIncrease = Number(args[12]);
			} else {
				var i:Number = 0;
				while (2* i + 5 < args.length){
					if (!specify(args[2 * i + 4], Number(args[2 * i + 5])))
						return;
					i++;
				}
			}
			autoCustom();
		}
		
		private function rampActivate(args){
			frequencyOfIncreaseX = Number(args[0]);
			if (frequencyOfIncreaseX < 1)
				frequencyOfIncreaseX = 1;
			randomChanceX = -0.1;
			randomChanceY = -0.1;
			autoCustom();
		}
		
		public function autoFunc(){
			tX = 0;
			tY = 0;
			count = 1;
			customPause = false;
			missed = false; 
			penOut = false;
			lastGPosX = g.currentPos.x;
			lastGPosY = g.currentPos.y;
			if (maxX < lastGPosX)
				goingDownX = false;
			else 
				goingDownX = true;
			if (maxY < lastGPosY)
				goingDownY = false;
			else 
				goingDownY = true;
			finishX = false;
			finishY = false;
			baseMinX = minX;
			baseMaxX = maxX;
			baseSpeedDownX = speedDownX;
			baseSpeedUpX = speedUpX;
			baseDelayDownX = delayDownX;
			baseDelayUpX = delayUpX;
			baseMinY = minY;
			baseMaxY = maxY;
			baseSpeedDownY = speedDownY;
			baseSpeedUpY = speedUpY;
			baseDelayDownY = delayDownY;
			baseDelayUpY = delayUpY;
			return function():Point{
				var current:Point = new Point(0,0);
				if (mousePressed)
					g.her.mousePressed();
				else
					g.her.mouseReleased(new MouseEvent(MouseEvent.MOUSE_UP))
				if (!customPause){
					if (!g.him.handOpen){
						if (goingDownX){
							if (!finishX && lastGPosX + speedDownX >= maxX){
								finishX = true;
								tX = delayDownX;
								endDirectX = true;
							}
							else if (!finishX){
								if (tX >= 2)
									current.x = lastGPosX + speedDownX;
								else if (tX == 0)
									current.x = lastGPosX + speedDownX/4;
								else 
									current.x = lastGPosX + speedDownX/2;
								tX++;
							}
							if (finishX){
								if (tX > 1)
									current.x = maxX;
								else {
									current.x = maxX;
									finishX = false;
									goingDownX = false;
								}
								if (current.x > maxX)
									current.x = maxX;
								tX--;
							}
						} else {
							if (!finishX && lastGPosX - speedUpX <= minX){
								finishX = true;
								tX = delayUpX;
								endDirectX = true;
							}
							else if (!finishX){
								if (tX >= 2)
									current.x = lastGPosX - speedUpX;
								else if (tX == 0)
									current.x = lastGPosX - speedUpX/4;
								else 
									current.x = lastGPosX - speedUpX/2;
								tX++;
							}
							if (finishX){
								if (tX > 1)
									current.x = minX;
								else {
									finishX = false;
									goingDownX = true;
									current.x = minX;
								}
								if (current.x < minX)
									current.x = minX;
								tX--;
							}
						}
						if (goingDownY){
							if (!finishY && lastGPosY + speedDownY >= maxY){
								finishY = true;
								tY = delayDownY;
								endDirectY = true;
							} else if (!finishY){
								if (tY >= 2)
									current.y = lastGPosY + speedDownY;
								else if (tY == 0)
									current.y = lastGPosY + speedDownY/4;
								else 
									current.y = lastGPosY + speedDownY/2;
								tY++;
							}
							if (finishY){
								if (tY > 1)
									current.y = maxY;
								else {
									finishY = false;
									goingDownY = false;
									current.y = maxY;
								}
								if (current.y > maxY)
									current.y = maxY;
								tY--;
							}
						} else {
							if (!finishY && lastGPosY - speedUpY <= minY){
								finishY = true;
								tY = delayUpY;
								endDirectY = true;
							}
							else if (!finishY){
								if (tY >= 2)
									current.y = lastGPosY - speedUpY;
								else if (tY == 0)
									current.y = lastGPosY - speedUpY/4;
								else 
									current.y = lastGPosY - speedUpY/2;
									tY++;
							}
							if (finishY){
								if (tY > 1)
									current.y = minY;
								else {
									finishY = false;
									goingDownY = true;
									current.y = minY;
								}
								if (current.y < minY)
									current.y = minY;
								tY--;
							}
						}
						if (count % frequencyOfIncreaseX < 1){
							incrementX();
						}
						if (count % frequencyOfIncreaseY < 1){
							incrementY();
						}
						if (main.animtools_comm.positiontype == 0){
							if (!missed){
								if (g.penisOut && !mousePressed){
									if (penOut){
										missed = true;
										penOut = false;
									} else {
										penOut = true;
									}
								} else 
									penOut = false;
							}								
						}
						if (missed){
							var tempSpeed;
							if (speedDownX < speedUpX)
								tempSpeed = speedUpX;
							else
								tempSpeed = speedUpX;
							current.x = lastGPosX - tempSpeed;
							if (current.x <= -0.2){
								current.x = -0.2;
								missedTime = count + 9;
								missed = false;
								penOut = false;
								goingDownX = true;
								tX = 0;
							}
						}
						if (count < missedTime)
							current.x = -0.2;
						count++;
						lastGPosX = current.x;
						lastGPosY = current.y;
					}
					if (count >= 360000){
						count = 0;
						missedTime = 0;
					}
					if (Math.random() <= randomChanceX){
						randomizeX();
					}
					if (Math.random() <= randomChanceY){
						randomizeY();
					}
					if (callbackActive){
						var comp = new Array;
						for (var i = 0; i < 3; i++){
							comp.push(compareTest(tests[i]));
							if (comp[i] && tests[i].trigger != null){
								alterValue(tests[i].trigger.split("~"));
								tests[i].repeat--;
								if (tests[i].repeat == 0)
									tests[i].trigger = null;
							}
						}
						if (comp[0] && comp[1] && comp[2]){
							callbackActive = false;
							triggerLine(callbackLine);
						}
					}
					endDirectX = false;
					endDirectY = false;
					return current;
				} else {
					return g.currentPos;
				}
			};
		}
		
		private function customHold(...args){
			holdPoint = g.currentPos;
			customStartCheck()
			lp.addPre(holdFunc(), false);
			lp.hooked = false;
		}
		
		public function holdFunc(){
			return function():Point {return holdPoint;};
		}
		
		private function incrementX(){
			if (randomChanceX < 0){
				maxX += maxXIncrease;
				minX += minXIncrease;
				speedDownX += speedDownXIncrease;
				speedUpX += speedUpXIncrease;
				delayDownX += delayDownXIncrease;
				delayUpX += delayUpXIncrease;
				if (maxX > 1.2)
					maxX = 1.2
				else if (maxX < -0.2)
					maxX = -0.2;
				if (minX > 1.2)
					minX = 1.2
				else if (minX < -0.2)
					minX = -0.2;
				if (minX > maxX){
					var temp;
					temp = minX;
					minX = maxX;
					maxX = temp;
					temp = minXIncrease;
					minXIncrease = maxXIncrease;
					maxXIncrease = temp;
				}
				if (speedDownX > maxSpeedX)
					speedDownX = maxSpeedX;
				else if (speedDownX < maxSpeedX/100)
					speedDownX = maxSpeedX/100;
				if (speedUpX > maxSpeedX)
					speedUpX = maxSpeedX;
				else if (speedUpX < maxSpeedX/100)
					speedUpX = maxSpeedX/100;
				if (delayDownX < 1)
					delayDownX = 1;
				if (delayUpX < 1)
					delayUpX = 1;
			} else {
				baseMaxX += maxXIncrease;
				baseMinX += minXIncrease;
				baseSpeedDownX += speedDownXIncrease;
				baseSpeedUpX += speedUpXIncrease;
				baseDelayDownX += delayDownXIncrease;
				baseDelayUpX += delayUpXIncrease;
				if (baseMaxX > 1.2)
					baseMaxX = 1.2
				else if (baseMaxX < -0.2)
					baseMaxX = -0.2;
				if (baseMinX > 1.2)
					baseMinX = 1.2
				else if (baseMinX < -0.2)
					baseMinX = -0.2;
				if (baseMinX > baseMaxX){
					var temp;
					temp = baseMinX;
					baseMinX = baseMaxX;
					baseMaxX = temp;
					temp = minXIncrease;
					minXIncrease = maxXIncrease;
					maxXIncrease = temp;
				}
				if (baseSpeedDownX > maxSpeedX)
					baseSpeedDownX = maxSpeedX;
				else if (baseSpeedDownX < maxSpeedX/100)
					baseSpeedDownX = maxSpeedX/100;
				if (baseSpeedUpX > maxSpeedX)
					baseSpeedUpX = maxSpeedX;
				else if (baseSpeedUpX < maxSpeedX/100)
					baseSpeedUpX = maxSpeedX/100;
				if (baseDelayDownX < 1)
					baseDelayDownX = 1;
				if (baseDelayUpX < 1)
					baseDelayUpX = 1;
			}
		}
		
		private function incrementY(){
			if (randomChanceY < 0){
				maxY += maxYIncrease;
				minY += minYIncrease;
				speedDownY += speedDownYIncrease;
				speedUpY += speedUpYIncrease;
				delayDownY += delayDownYIncrease;
				delayUpY += delayUpYIncrease;
				if (maxY > 1)
					maxY = 1;
				else if (maxY < -1)
					maxY = -1;
				if (minY > 1)
					minY = 1;
				else if (minY < -1)
					minY = -1;
				if (minY > maxY){
					var temp;
					temp = minY;
					minY = maxY;
					maxY = temp;
					temp = minYIncrease;
					minYIncrease = maxYIncrease;
					maxYIncrease = temp;
				}
				if (speedDownY > maxSpeedY)
					speedDownY = maxSpeedY;
				else if (speedDownY < maxSpeedY/100)
					speedDownY = maxSpeedY/100;
				if (speedUpY > maxSpeedY)
					speedUpY = maxSpeedY;
				else if (speedUpY < maxSpeedY/100)
					speedUpY = maxSpeedY/100;
				if (delayDownY < 1)
					delayDownY = 1;
				if (delayUpY < 1)
					delayUpY = 1;
			} else {
				baseMaxY += maxYIncrease;
				baseMinY += minYIncrease;
				baseSpeedDownY += speedDownYIncrease;
				baseSpeedUpY += speedUpYIncrease;
				baseDelayDownY += delayDownYIncrease;
				baseDelayUpY += delayUpYIncrease;
				if (baseMaxY > 1)
					baseMaxY = 1;
				else if (baseMaxY < -1)
					baseMaxY = -1;
				if (baseMinY > 1)
					baseMinY = 1;
				else if (baseMinY < -1)
					baseMinY = -1;
				if (baseMinY > baseMaxY){
					var temp;
					temp = baseMinY;
					baseMinY = baseMaxY;
					baseMaxY = temp;
					temp = minYIncrease;
					minYIncrease = maxYIncrease;
					maxYIncrease = temp;
				}
				if (baseSpeedDownY > maxSpeedY)
					baseSpeedDownY = maxSpeedY;
				else if (baseSpeedDownY < maxSpeedY/100)
					baseSpeedDownY = maxSpeedY/100;
				if (baseSpeedUpY > maxSpeedY)
					baseSpeedUpY = maxSpeedY;
				else if (baseSpeedUpY < maxSpeedY/100)
					baseSpeedUpY = maxSpeedY/100;
				if (baseDelayDownY < 1)
					baseDelayDownY = 1;
				if (baseDelayUpY < 1)
					baseDelayUpY = 1;
			}
		}
		
		private function randomizeX(){
			var avgPosX = (maxX + minX)/2;
			var scale = randomScaleX * (Math.random() * 2 - 1);
			maxX = baseMaxX + avgPosX * scale;
			scale = randomScaleX * (Math.random() * 2 - 1);
			minX = baseMinX + avgPosX * scale;
			scale = randomScaleX * (Math.random() * 2 - 1) + 1;
			speedDownX = baseSpeedDownX * scale;
			scale = randomScaleX * (Math.random() * 2 - 1) + 1;
			speedUpX = baseSpeedUpX * scale;
			scale = randomScaleX * (Math.random() * 2 - 1) + 1;
			delayDownX = Math.round(baseDelayDownX * scale);
			scale = randomScaleX * (Math.random() * 2 - 1) + 1;
			delayUpX = Math.round(baseDelayUpX * scale);
			if (maxX > 1.2)
				maxX = 1.2
			else if (maxX < -0.2)
				maxX = -0.2;
			if (minX > 1.2)
				minX = 1.2
			else if (minX < -0.2)
				minX = -0.2;
			if (minX > maxX)
				minX = maxX;
			if (speedDownX > maxSpeedX)
				speedDownX = maxSpeedX;
			else if (speedDownX < maxSpeedX/100)
				speedDownX = maxSpeedX/100;
			if (speedUpX > maxSpeedX)
				speedUpX = maxSpeedX;
			else if (speedUpX < maxSpeedX/100)
				speedUpX = maxSpeedX/100;
			if (delayDownX < 1)
				delayDownX = 1;
			if (delayUpX < 1)
				delayUpX = 1;
		}
		
		private function randomizeY(){
			var avgPosY = (maxY + minY + 2)/2;
			var scale = randomScaleY * (Math.random() * 2 - 1);
			maxY = baseMaxY + avgPosY * scale;
			scale = randomScaleY * (Math.random() * 2 - 1);
			minY = baseMinY + avgPosY * scale;
			scale = randomScaleY * (Math.random() * 2 - 1) + 1;
			speedDownY = baseSpeedDownY * scale;
			scale = randomScaleY * (Math.random() * 2 - 1) + 1;
			speedUpY = baseSpeedUpY * scale;
			scale = randomScaleY * (Math.random() * 2 - 1) + 1;
			delayDownY = Math.round(baseDelayDownY * scale);
			scale = randomScaleY * (Math.random() * 2 - 1) + 1;
			delayUpY = Math.round(baseDelayUpY * scale);
			if (maxY > 1)
				maxY = 1
			else if (maxY < -1)
				maxY = -1;
			if (minY > 1)
				minY = 1;
			else if (minY < -1)
				minY = -1;
			if (minY > maxY)
				minY = maxY;
			if (speedDownY > maxSpeedY)
				speedDownY = maxSpeedY;
			else if (speedDownY < maxSpeedY/100)
				speedDownY = maxSpeedY/100;
			if (speedUpY > maxSpeedY)
				speedUpY = maxSpeedY;
			else if (speedUpY < maxSpeedY/100)
				speedUpY = maxSpeedY/100;
			if (delayDownY < 1)
				delayDownY = 1;
			if (delayUpY < 1)
				delayUpY = 1;
		}
		
		private function stopProxy(){
			return function():void{
				if (lProxy.checkProxied(g.automaticControl, "getPos"))
					lp.restoreProxy(false);
				if (customActive){
					g.autoMode = autoMode;
					g.aCon = aCon;
					g.playRec = playRec;
					main.holdDown = holdDown;
					g.inGameMenu.setCBAuto();
					g.tongue = tongue;
					g.her.tongueToggled();
					g.inGameMenu.updateCBTongue();
					g.her.mouseReleased(new MouseEvent(MouseEvent.MOUSE_UP));
					mousePressed = false;
					customActive = false;
				}
			}			
		}
		
		private function stopCustom(args):void{
			if (lProxy.checkProxied(g.automaticControl, "getPos"))
				lp.restoreProxy(false);
			if (customActive){
				g.autoMode = autoMode;
				g.aCon = aCon;
				g.playRec = playRec;
				main.holdDown = holdDown;
				g.inGameMenu.setCBAuto();
				customActive = false;
				g.her.mouseReleased(new MouseEvent(MouseEvent.MOUSE_UP));
				mousePressed = false;
				g.tongue = tongue;
				g.her.tongueToggled();
				g.inGameMenu.updateCBTongue();
			}
		}
		
		private function changeInitRes(args):void{
			var x = Number(args[0]);
			if (x < 0)
				x = 0;
			else if (x > 100)
				x = 100;
			g.her.setIntroResistance(x);
			g.inGameMenu.updateResistanceSlider(false);
		}
		
		private function breakInitRes(args):void{
			setToDefaults();
			speedDownX = Number(args[0]) * maxSpeedX/100;
			if (args.length == 2)
				speedUpX = Number(args[1]) * maxSpeedX/100;
			else
				speedUpX = speedDownX;
			minX = (baseHilt-baseTipDiff*g.him.penisLengthScale-100)/500 - 0.07;
			maxX = 1.2;
			minY = 0;
			maxY = 0;
			delayUpX = 4;
			if (speedDownX < maxSpeedX/100)
				speedDownX = maxSpeedX/100;
			else if (speedDownX > maxSpeedX)
				speedDownX = maxSpeedX;
			if (speedUpX < maxSpeedX/100)
				speedUpX = maxSpeedX/100;
			else if (speedUpX > maxSpeedX)
				speedUpX = maxSpeedX;
			customStartCheck();
			lp.addPre(autoFunc(), false);
			lp.hooked = false;	
		}
		
		private function moveTongue(args):void{
			if (!customActive){
				autoMode = g.autoModeOn;
				aCon = main.aCon;
				playRec = main.playRec;
				holdDown = main.holdDown;
				tongue = g.tongue;
				customActive = true;
			}
			if (args[0].toUpperCase() == "IN")
				g.tongue = false;
			else if (args[0].toUpperCase() == "OUT")
				g.tongue = true;
			g.her.tongueToggled();
			g.inGameMenu.updateCBTongue();				
		}
		
		private function mouseSet(args):void{
			if (args[0].toUpperCase() == "DOWN"){
				g.her.mousePressed();
				mousePressed = true;
			}
			else if (args[0].toUpperCase() == "UP"){
				g.her.mouseReleased(new MouseEvent(MouseEvent.MOUSE_UP));
				mousePressed = false;
			}
		}
		
		private function moveToBalls(args):void{
			var str:Array = new Array("press");
			mouseSet(str);
			setToDefaults();
			minX = 1.1;
			maxX = 1.1;
			minY = 1;
			maxY = 1;
			speedDownX = Number(args[0]) * maxSpeedX/100;
			if (speedDownX < maxSpeedX/100)
				speedDownX = maxSpeedX/100;
			else if (speedDownX > maxSpeedX)
				speedDownX = maxSpeedX;
			speedUpX = speedDownX;
			speedDownY = speedDownX;
			speedUpY = speedDownX;
			customStartCheck();
			lp.addPre(autoFunc(), false);
			lp.hooked = false;
		}
		
		private function pauseCustom(args):void{
			customPause = true;
		}
		
		private function continueCustom(args):void{
			customPause = false;
		}
		
		private function setToDefaults(){
			minY = 0;
			maxY = 0;
			speedDownY = 0;
			speedUpY = 0;
			delayDownX = 3;
			delayDownY = 3;
			delayUpX = 3;
			delayUpY = 3;
			randomChanceX = -0.1;
			randomChanceY = -0.1;
			randomScaleX = 0.2;
			randomScaleY = 0.2;
			frequencyOfIncreaseX = 1000000;
			frequencyOfIncreaseY = 1000000;
			delayDownXIncrease = 0;
			delayUpXIncrease = 0;
			minXIncrease = 0;
			maxXIncrease = 0;
			speedDownXIncrease = 0;
			speedUpXIncrease = 0;
			baseDelayDownX = 0;
			baseDelayUpX = 0;
			baseSpeedDownX = 0;
			baseSpeedUpX = 0;
			delayDownYIncrease = 0;
			delayUpYIncrease = 0;
			minYIncrease = 0;
			maxYIncrease = 0;
			speedDownYIncrease = 0;
			speedUpYIncrease = 0;
			baseDelayDownY = 0;
			baseDelayUpY = 0;
			baseSpeedDownY = 0;
			baseSpeedUpY = 0;
		}
		
		private function convertString(position):Number{
			if (position.toUpperCase() == "HILT")
				return 1.2;
			else if (position.toUpperCase() == "CENTER")
				return (baseHilt-baseMidDiff*g.him.penisLengthScale - 100)/500;
			else if (position.toUpperCase() == "HEAD")
				return (baseHilt-baseHeadDiff*g.him.penisLengthScale-100)/500;
			else if (position.toUpperCase() == "TIP")
				return (baseHilt-baseTipDiff*g.him.penisLengthScale - 100)/500;
			else if (position.toUpperCase() == "OFF")
				return -0.2;
			else {				
				return Number(position)/71.43 -0.2;
			}
		}
		
		private function alterValue(args):void{
			var i = 0;
			if (args.length % 2 != 0){
				main.updateStatus("Invalid test line trigger length, must be made up of key:value pairs (even number of arguments.)");
				return;
			}
			while (2*i+1 < args.length){
				if (args[2*i].toUpperCase() == "LINE")
					callbackLine = args[2*i+1];
				else if (args[2*i].toUpperCase() == "TEST"){
					if (args[2*i+1].toUpperCase() == "ON"){
						var active = false;
						for each (var test in tests){
							if (test.active)
								active = true;
							if (test.func == getCounter && !callbackActive){
								if (missedTime > count){
									missedTime = missedTime - count + 1;
								}
								count = 1;
								test.value += 1;
							}
						}
						if (active && callbackLine != ""){
							callbackActive = true;
						}
					} else if (args[2*i+1].toUpperCase == "OFF")
						callbackActive = false;
					else {
						main.updateStatus("Bad argument to TEST, requires 'ON' or 'OFF', received: " + args[2*i+1].toUpperCase() + ".");
						break;
					}
				} else if ((args[2*i+1].substr(0,1) == "+" && !isNaN(Number(args[2*i+1].split("+")[1]))) || !isNaN(Number(args[2*i+1]))){
					specify(args[2*i], args[2*i+1]);
				} else {
					main.updateStatus("Invalid key for VALUE_CUSTOM, see notes for acceptable keys. Received: " + args[2*i].toUpperCase() + ".");
					break;
				}
				i++;
			}
		}
		
		private function compareTest(test:*){
			var testValue;
			if (!test.active)
				return true;
			if (test.func != getGoingDown && test.func != getGoingDownY)
				testValue = Number(test.value);
			else
				testValue = test.value;
			return test.comp(test.func, testValue);
		}
		
		private function triggerLine(lineType:String){
			lineType = "[" + lineType + "]";
			if(!g.dialogueControl.words)
			{
				g.dialogueControl.words = new Array();
			}

			if(g.dialogueControl.waitingToContinue || g.dialogueControl.speaking) //currently in dialog
			{
				g.dialogueControl.instantStop();
				g.dialogueControl.waitingToContinue = false;
				g.dialogueControl.speaking = false;
				g.dialogueControl.startSpeakingPhrase(new DialogueLine(lineType, null));
				g.dialogueControl.speaking = true;
			}
			else
			{
				g.dialogueControl.startSpeakingPhrase(new DialogueLine(lineType, null));
				g.dialogueControl.speaking = true;
			}
		}
		
		private function specify(key:String, entry):Boolean{
			var addValue = false;
			var value;
			key = key.toUpperCase();
			if (entry.substr(0,1) == "+"){
				addValue = true;
				value = Number(entry.split("+")[1]);
			} else
				value = Number(entry);
			if (key == "MIN"){
				if (addValue)
					minX += value/71.43;
				else
					minX = value/71.43 - 0.2;
				if (minX < -0.2)
					minX = -0.2;
				else if (minX > 1.2)
					minX = 1.2;
				if (minX > maxX)
					minX = maxX;
				baseMaxX = maxX;
				baseMinX = minX;
				return true;
			} else if (key == "MAX"){
				if (addValue)
					maxX += value/71.43;
				else
					maxX = value/71.43 - 0.2;
				if (maxX < -0.2)
					maxX = -0.2;
				else if (maxX > 1.2)
					maxX = 1.2;
				if (minX > maxX)
					minX = maxX;
				baseMaxX = maxX;
				baseMinX = minX;
				return true;
			} else if (key == "SPDDOWN"){
				if (addValue)
					speedDownX += value * maxSpeedX/100;
				else
					speedDownX = value * maxSpeedX/100;
				if (speedDownX < maxSpeedX/100)
					speedDownX = maxSpeedX/100;
				else if (speedDownX > maxSpeedX)
					speedDownX = maxSpeedX;
				baseSpeedDownX = speedDownX;
				return true;
			} else if (key == "SPDUP"){
				if (addValue)
					speedUpX += value * maxSpeedX/100;
				else
					speedUpX = value * maxSpeedX/100;
				if (speedUpX < maxSpeedX/100)
					speedUpX = maxSpeedX/100;
				else if (speedUpX > maxSpeedX)
					speedUpX = maxSpeedX;
				baseSpeedUpX = speedUpX;
				return true;
			} else if (key == "DLYDOWN"){
				if (addValue)
					delayDownX += value;
				else
					delayDownX = value;
				if (delayDownX < 1)
					delayDownX = 1;
				baseDelayDownX = delayDownX;
				return true;
			} else if (key == "DLYUP"){
				if (addValue)
					delayUpX += value;
				else
					delayUpX = value;
				if (delayUpX < 1)
					delayUpX = 1;
				baseDelayUpX = delayUpX;
				return true;
			} else if (key == "MININC"){
				if (addValue)
					minXIncrease += value/714.3;
				else
					minXIncrease = value/714.3;
				return true;
			} else if (key == "MAXINC"){
				if (addValue)
					maxXIncrease += value/714.3;
				else
					maxXIncrease = value/714.3;
				return true;
			} else if (key == "SPDUPINC"){
				if (addValue)
					speedUpXIncrease += value * maxSpeedX/1000;
				else
					speedUpXIncrease = value * maxSpeedX/1000;
				return true;
			} else if (key == "SPDDOWNINC"){
				if (addValue)
					speedDownXIncrease += value * maxSpeedX/1000;
				else
					speedDownXIncrease = value * maxSpeedX/1000;
				return true;
			} else if (key == "DLYUPINC"){
				if (addValue)
					delayUpXIncrease += value;
				else
					delayUpXIncrease = value;
				return true;
			} else if (key == "DLYDOWNINC"){
				if (addValue)
					delayDownXIncrease += value;
				else
					delayDownXIncrease = value;
				return true;
			} else if (key == "FREQINC"){
				if (addValue)
					frequencyOfIncreaseX += value;
				else
					frequencyOfIncreaseX = value;
				if (frequencyOfIncreaseX < 1)
					frequencyOfIncreaseX = 1;
				return true;
			} else if (key == "RANDCHAN"){
				if (addValue)
					randomChanceX += value/1000;
				else
					randomChanceX = value/1000;
				if (randomChanceX)
					randomChanceX;
				return true;
			} else if (key == "RANDSCALE"){
				if (addValue)
					randomScaleX += value/100;
				else
					randomScaleX = value/100;
				if (randomScaleX < 0)
					randomScaleX = 0;
				else if (randomScaleX > 100)
					randomScaleX = 100;
				return true;
			} else if (key == "MINY"){
				if (addValue)
					minY += value/50;
				else
					minY = value/50 - 1;
				if (minY < -1)
					minY = -1;
				else if (minY > 1)
					minY = 1;
				if (minY > maxY)
					minY = maxY;
				baseMaxY = maxY;
				baseMinY = minY;
				return true;
			} else if (key == "MAXY"){
				if (addValue)
					maxY += value/50;
				else
					maxY = value/50 - 1;
				if (maxY < -1)
					maxY = -1;
				else if (maxY > 1)
					maxY = 1;
				if (minY > maxY)
					minY = maxY;
				baseMaxY = maxY;
				baseMinY = minY;
				return true;
			} else if (key == "SPDDOWNY"){
				if (addValue)
					speedDownY += value * maxSpeedY/100;
				else
					speedDownY = value * maxSpeedY/100;
				if (speedDownY < maxSpeedY/100)
					speedDownY = maxSpeedY/100;
				else if (speedDownY > maxSpeedY)
					speedDownY = maxSpeedY;
				baseSpeedDownY = speedDownY;
				return true;
			} else if (key == "SPDUPY"){
				if (addValue)
					speedUpY += value * maxSpeedY/100;
				else
					speedUpY = value * maxSpeedY/100;
				if (speedUpY < maxSpeedY/100)
					speedUpY = maxSpeedY/100;
				else if (speedUpY > maxSpeedY)
					speedUpY = maxSpeedY;
				baseSpeedUpY = speedUpY;
				return true;
			} else if (key == "DLYDOWNY"){
				if (addValue)
					delayDownY += value;
				else
					delayDownY = value;
				if (delayDownY < 1)
					delayDownY = 1;
				baseDelayDownY = delayDownY;
				return true;
			} else if (key == "DLYUPY"){
				if (addValue)
					delayUpY += value;
				else
					delayUpY = value;
				if (delayUpY < 1)
					delayUpY = 1;
				baseDelayUpY = delayUpY;
				return true;
			} else if (key == "MININCY"){
				if (addValue)
					minYIncrease += value/500;
				else
					minYIncrease = value/500;
				return true;
			} else if (key == "MAXINCY"){
				if (addValue)
					maxYIncrease += value/500;
				else
					maxYIncrease = value/500;
				return true;
			} else if (key == "SPDUPINCY"){
				if (addValue)
					speedUpYIncrease += value * maxSpeedY/1000;
				else
					speedUpYIncrease = value * maxSpeedY/1000;
				return true;
			} else if (key == "SPDDOWNINCY"){
				if (addValue)
					speedDownYIncrease += value * maxSpeedY/1000;
				else
					speedDownYIncrease = value * maxSpeedY/1000;
				return true;
			} else if (key == "DLYUPINCY"){
				if (addValue)
					delayUpYIncrease += value;
				else
					delayUpYIncrease = value;
				return true;
			} else if (key == "DLYDOWNINCY"){
				if (addValue)
					delayDownYIncrease += value;
				else
					delayDownYIncrease = value;
				return true;
			} else if (key == "FREQINCY"){
				if (addValue)
					frequencyOfIncreaseY += value;
				else
					frequencyOfIncreaseY = value;
				if (frequencyOfIncreaseY < 1)
					frequencyOfIncreaseY = 1;
				return true;
			} else if (key == "RANDCHANY"){
				if (addValue)
					randomChanceY += value/1000;
				else
					randomChanceY = value/1000;
				return true;
			} else if (key == "RANDSCALEY"){
				if (addValue)
					randomScaleY += value/100;
				else
					randomScaleY = value/100;
				if (randomScaleY < 0)
					randomScaleY = 0;
				else if (randomScaleY > 100)
					randomScaleY = 100;
				return true;
			} else {
				main.updateStatus("No matching key for value_custom which accepts a numerical value. Key: " + key + ".");
				return false;
			}
		}
		
		private function setTests(args):void{
			if (Number(args[0]) < 3 && Number(args[0]) >= 0){
				if (!setTestsHelp(tests[Number(args[0])], args[1].toUpperCase(), args[2], args[3].toUpperCase())){
					main.updateStatus("Test set improperly.");
					return;
				}
			} else {
				main.updateStatus("Bad test number in test setup.")
				return;
			}
			if (args.length == 6){
				if (!isNaN(Number(args[5])))
					tests[Number(args[0])].repeat = Number(args[5]);
				else {
					main.updateStatus("When providing a test trigger, final value in SET_TEST must be an integer >= 1");
					return;
				}
				tests[Number(args[0])].trigger = args[4];					
			} else if (args.length == 4) {
				tests[Number(args[0])].trigger = null;
			} else {
				main.updateStatus("Invalid number of arguments to SET_TEST, requires 4 or 6, got: " + args.length);
				tests[Number(args[0])].trigger = null;
			}
		}
		
		private function setTestsHelp(test, key, value, comp){
			if (!isNaN(Number(value))){
				var tempVal = Number(value);
				if (key == "MIN"){
					test.func = getMin;
					test.value = tempVal/71.43 - 0.2;
				} else if (key == "MAX"){
					test.func = getMax;
					test.value = tempVal/71.43 - 0.2;
				} else if (key == "CURRENT"){
					test.func = getCurrent;
					test.value = tempVal/71.43 - 0.2;
				} else if (key == "SPDDOWN"){
					test.func = getSpeedDown;
					test.value = tempVal * maxSpeedX/100;
				} else if (key == "SPDUP"){
					test.func = getSpeedUp;
					test.value = tempVal * maxSpeedX/100;
				} else if (key == "DLYDOWN"){
					test.func = getDelayDown;
					test.value = tempVal;
				} else if (key == "DLYUP"){
					test.func = getDelayUp;
					test.value = tempVal;
				} else if (key == "MINY"){
					test.func = getMinY;
					test.value = tempVal/50 - 1;
				} else if (key == "MAXY"){
					test.func = getMaxY;
					test.value = tempVal/50 - 1;
				} else if (key == "CURRENTY"){
					test.func = getCurrentY;
					test.value = tempVal/50 - 1;
				} else if (key == "SPDDOWNY"){
					test.func = getSpeedDownY;
					test.value = tempVal * maxSpeedY/100;
				} else if (key == "SPDUPY"){
					test.func = getSpeedUpY;
					test.value = tempVal * maxSpeedY/100;
				} else if (key == "DLYDOWNY"){
					test.func = getDelayDownY;
					test.value = tempVal;
				} else if (key == "DLYUPY"){
					test.func = getDelayUpY;
					test.value = tempVal;
				} else if (key == "COUNT") {
					test.func = getCounter;
					test.value = tempVal;
				} else
					return false;
			} else if (key == "MOVE") {
					test.func = getGoingDown;
					test.value = value.toUpperCase();
			} else if (key == "MOVEY") {
					test.func = getGoingDownY;
					test.value = value.toUpperCase();
			} else
				return false;
			if (comp == "G")
				test.comp = greater;
			else if (comp == "GE")
				test.comp = greaterEqual;
			else if (comp == "E")
				test.comp = equal;
			else if (comp == "LE")
				test.comp = lessEqual;
			else if (comp == "L")
				test.comp = less;
			else
				return false;
			return true;
		}
		
		private function activeTest(args){
			var testNumber = Number(args[0]);
			if (testNumber >= 0 && testNumber < 3){
				if (tests[testNumber].func != null){
					if (args[1].toUpperCase() == "ON")
						tests[testNumber].active = true;
					else if (args[1].toUpperCase() == "OFF")
						tests[testNumber].active = false;
					else
						main.updateStatus("Invalid activity setting when attempting to update test " + testNumber + ".");
				} else {
					main.updateStatus("Test " + testNumber + " has not been set.");
				}
			} else {
				main.updateStatus("Bad test number in test activation, number given was " + testNumber + ".");
				main.updateStatus("Valid test numbers are 0, 1, or 2.");
			}
		}
		
		public function getMin():Number{
			return minX;
		}
		
		public function getMax():Number{
			return maxX;
		}
		
		public function getSpeedDown():Number{
			return speedDownX;
		}
		
		public function getSpeedUp():Number{
			return speedUpX;
		}
		
		public function getDelayDown():Number{
			return delayDownX;
		}
		
		public function getDelayUp():Number{
			return delayUpX;
		}
		
		public function getGoingDown():String{
			if (goingDownX == false && endDirectX == false)
				return "GOUP";
			else if (goingDownX == true && endDirectX == false)
				return "GODOWN";
			else if (goingDownX == false && endDirectX == true)
				return "UP";
			else
				return "DOWN";
		}
		
		public function getMinY():Number{
			return minY;
		}
		
		public function getMaxY():Number{
			return maxY;
		}
		
		public function getSpeedDownY():Number{
			return speedDownY;
		}
		
		public function getSpeedUpY():Number{
			return speedUpY;
		}
		
		public function getDelayDownY():Number{
			return delayDownY;
		}
		
		public function getDelayUpY():Number{
			return delayUpY;
		}
		
		public function getCounter():Number{
			return count;
		}
		
		public function getCurrent():Number{
			return g.currentPos.x;
		}
		
		public function getCurrentY():Number{
			return g.currentPos.y;
		}
		
		public function getGoingDownY():String{
			if (goingDownY == false && endDirectY == false)
				return "GOUP";
			else if (goingDownY == true && endDirectY == false)
				return "GODOWN";
			else if (goingDownY == false && endDirectY == true)
				return "UP";
			else
				return "DOWN";
		}
		
		public function greaterEqual(func:Function, val:Number){
			return func() >= val;
		}
		
		public function greater(func:Function, val:Number){
			return func() > val;
		}
		
		public function equal(func:Function, val){
			return func() == val;
		}
		
		public function lessEqual(func:Function, val:Number){
			return func() <= val;
		}
		
		public function less(func:Function, val:Number){
			return func() < val;
		}
	}
}